#HDMENU

HDmenu - Atari Harddisk Men
2022-2025 Jeffrey Young
Basierend auf Atari ST Harddisk Menu von Simon Sunnyboy <http://paradize.atari.org/>

## Kurzfassung

Dies ist ein Men fr die Verwendung auf der Festplatte.

- Programme auf der Festplatte werden aus einer Datenbank aufgelistet und
  bei Auswahl ausgefhrt
- Men kann mit Timeout umgangen werden, um es ohne sauberen Neustart im
  AUTO-Ordner zu behalten
- benutzerfreundliche Tastaturnavigation, keine Maus erforderlich fr
  enge Wohnzimmer
- praktische Joystick-Navigation in das Programm integriert
- das Men merkt sich optional den zuletzt ausgefhrten Eintrag
- Spiele knnen optional einen Screenshot im NEO-Format anzeigen
- Textbetrachter ermglicht das Lesen von Handbchern oder anderen Texten fr
  jedes Spiel
- Textbetrachter kann Text entweder in niedriger oder mittlerer Auflsung
  anzeigen
- Textbetrachter in niedriger Auflsung kann Text entweder in 40 oder 80
  Spalten anzeigen
- gespeicherte Spielstnde knnen geladen werden, wenn sie verfgbar sind
- optional kann Musik im Hintergrund abgespielt werden
- konfigurierbare Bildschirmschonerfunktion
- Datenbank kann sortiert werden
- Lieblingsspiele knnen markiert und in einer separaten Liste angezeigt werden
- Spielen kann eine zugehrige Kategorie zugewiesen werden
- optionale Statuszeile zeigt Anzahl der Spiele in der Liste und zustzliche
  Informationen

Die Idee ist, eine schnelle Tastatur-/Joysticknavigation zu auf der Festplatte
installierten Spielen zu ermglichen, ohne auf dem Desktop herumklicken zu
mssen.

## Systemanforderungen

- Atari ST/STE/TT/Falcon 030/Apollo V4SA/CT60 mit Farbdisplay (ST-HIGH wird nicht untersttzt)
- Hatari/Steem Emulatoren untersttzt
- Festplatte oder hnliches empfohlen
- mindestens 1MB empfohlen
- SingleTOS (MinT oder MagiC werden nicht untersttzt)

## Tastaturbelegung

- F1 oder HELP um die Hilfemen anzuzeigen
- F2 ffnet das Konfigurationsmen (Konfiguration kann auf Festplatte gespeichert werden)
- F3 fr die Textsuche in der Datenbank - findet beliebige Teile aus aus allen Spieleintrgen
- F4 Textsuche wiederholen
- F5 zeigt Favoriten fr aktuelle Liste an
- F6 zeigt eine Liste der antzeigbaren Kategorien an
- F7 Datenbankdatei mit allen nderungen auf Festplatte speichern
- F8 Datenbank alphabetisch sortieren
- F9 Liste aller fr den aktuellen Spieleintrag verfgbaren Spielstnde anzeigen 
     (Cursor-Rechts vom Screenshot zeigt auch alle Speicherstnde fr das Spiel an.)
- F10 Computer zurcksetzen (Achtung: Es werden keine nderungen auf der Festplatte
      gespeichert)

- Shift-F1 zeigt die Spielinformationen aus der Datenbank an
- Shift-F2 Liste der verfgbaren Musikdateien anzeigen. Siehe Abschnitt "Musik"
- Shift-F3 Liste der verfgbaren Schriftdateien anzeigen. Siehe Abschnitt "Schriftarten"
- Shift-F4 zeigt den Credits-Bildschirm an
- Shift-F5 Favoriten fr aktuelle Liste lschen
- Shift-F6 Dem aktuell ausgewhlten Eintrag eine Kategorie zuweisen
- Shift-F7 Datenbank neu von der Festplatte laden
- Shift-F8 Bildschirmschoner manuell aktivieren
- Shift-F10 Men verlassen und mit dem Systemstart fortfahren

- Cursor-Auf/Ab zum Auswhlen von Eintrgen
- Shift-Cursor-Auf/Ab fr seitenweise Navigation
- ClrHome um zum Anfang der Liste zu gelangen
- Shift-ClrHome um zum Ende der Liste zu gelangen
- ENTER um das ausgewhlte Spiel auszufhren
- Shift-ENTER ermglicht die Auswahl der ausfhrbaren Spieldatei aus allen
  im aktuellen Spielordner gefundenen
- ESC oder die jeweilige aufrufende Taste fhrt zurck zum letzten aktiven Bildschirm
- Cursor Rechts von der Spieleliste zeigt den Screenshot an, falls verfgbar
- Cursor Links von der Spieleliste zeigt alle Textdateien an, die im
  Spieleordner vorhanden sind. Wenn mehrere Textdateien vorhanden sind, kann
  der Benutzer eine auswhlen, die angezeigt werden soll.

- <Leertaste> schaltet Favoritenstatus fr den ausgewhlten Eintrag um
- Bei der Eingabe von Buchstaben/Zahlen wird in Echtzeit zum entsprechenden
  Eintrag in der Liste gesprungen.

## Joystick-Steuerung

Das Men kann optional ber einen Joystick in Port 1 gesteuert werden. Die
Richtungsbewegungen des Joysticks entsprechen den Cursortasten auf der
Tastatur. Die Reaktion auf das Drcken des Feuerknopfs variiert je nach Kontext.

- Menliste/Screenshot-Modus

  - In den Listen- und Screenshot-Modi wird der Fensterinhalt bei Bettigung des 
    Joystick nach oben oder unten zeilenweise gescrollt.

  - Gedrckt halten der Feuertaste whrend der Bettgigung des Joystick nach
    oben oder unten bewirkt seitenweises scrollen des Fensterinhalts.

  - Eine kurze Bettigung des Feuerknopf fhrt den ausgewhlte Eintrag aus.
    Dies gilt auch auf dem Bildschirm mit der Liste der Spielstnde.

- Textbetrachter

  - Im Textbetrachter  wird der Fensterinhalt bei Bettigung des 
    Joystick nach oben oder unten zeilenweise gescrollt.

  - Gedrckt halten der Feuertaste whrend der Bettgigung des Joystick nach
    oben oder unten bewirkt seitenweises scrollen des Fensterinhalts.

  - Kurzes Drcken der Feuertaste springt zurck in den Menlistenmodus.

## Ausfhrung von Programmen

- Wenn die mit einem Meneintrag verknpfte ausfhrbare Datei auf der
  Festplatte nicht gefunden wird, wird eine Meldung angezeigt.
- Wenn in der Datenbank vorhanden, wird das zu verwendende Laufwerk angezeigt und  
  verwendet, sonst das aktuelle Laufwerk.
- Das Verzeichnis wird zum angegebenen gendert und die Datei ausgefhrt.
- Wenn das Programm zu GEMDOS zurckkehrt, wird der ST zurckgesetzt.

## Suchen

Die aktuelle Datenbank kann durchsucht werden.
Drcken Sie F3, um den Suchdialog zu ffnen. Geben Sie die zu suchende Zeichenfolge
mit A-Z, 0-9 oder Leerzeichen ein.
Drcken Sie F4, um zur nchsten bereinstimmung zu springen.
Drcken Sie erneut F3, um einen neuen Suchbegriff einzugeben.

Darber hinaus bietet das Men jetzt eine Echtzeitsuche nach Spieletiteln.
Beginnen Sie in der Menliste oder im Screenshot-Modus mit der Eingabe von
Buchstaben und das Programm "springt" zum ersten passenden Titel. Diese
Funktion funktioniert am besten, wenn die Menliste alphabetisch sortiert ist.

## Hilfsfunktionen

Das Konfigurationsmen stellt einige kleine Helfer bereit.

- Die 50/60 Hz Umschaltung kann auf einen festen Wert eingestellt werden
  oder die aktuelle Einstellung beibehalten
- Tastenklick ein/aus oder Beibehalten der Einstellung
- Timeout fr den Bootprompt und den Copyright-Bildschirm
- ndern der Taste fr die Startsequenz auf F1-F10, TAB, LEERTASTE or ENTER
- Einstellungen beim Beenden des Programms speichern (Hinweis: erfolgt nicht bei Reset mit F10)
- Option "Letzte Auswahl merken" zum Umschalten, ob der letzte Spieldurchlauf
  gespeichert wird
- Bildschirmschonerbetrieb einstellen (aus, 5, 15, 30 oder 60 Minuten)
- ST-LOW kann zum Ausfhren eines ausgewhlten Programms erzwungen werden
- Hintergrundmusik ein- oder ausschalten oder eine externe Musikdatei auswhlen
- Statuszeile ein- oder ausschalten
- Option zur Sicherung der CSV-Datei, um vor dem Speichern von nderungen eine
  Kopie der aktuellen CSV-Datei zu erstellen

## Screenshots

Screenshots sollten im NEO-Format vorliegen und sich im selben Verzeichnis wie 
die ausfhrbare Spieldatei befinden. Der Dateiname des Screenshots sollte mit 
dem Namen des Spielordners bereinstimmen. Beispielsweise sollte 
Exolon;E:\GAMES\EXOLON\EXOLON.PRG den Screenshot mit dem Namen EXOLON.NEO im 
EXOLON-Ordner haben. Beim Anzeigen von Screenshots funktionieren alle 
normalen Navigationstasten genauso wie im normalen Listenmodus, einschlielich 
des Startens des Spiels und der Echtzeitsuche. 

Bitte beachten Sie, dass einige Spiele spezielle Hardwaretechniken verwenden, 
um die Anzahl der Farben auf dem Bildschirm und die Bildschirmauflsung  zu 
erhhen. HDMENU kann diese Techniken beim Anzeigen von Screenshots nicht 
verwenden, daher knnen einige Screenshots einen Spielbildschirm zeigen, 
der anders aussieht als im Spiel. 

## Textbetrachter

Das Men verfgt ber einen Textbetrachter. Dieser ermglicht die Anzeige 
aller Spielanleitungen, Cheat-Codes, Handbcher usw., die im Spielornder 
vorhanden sein knnen. Wenn mehrere Textdateien vorhanden sind, wird dem 
Benutzer eine Liste angezeigt, aus der er die anzuzeigende Datei auswhlen 
kann. Derzeit werden alle Dateien mit folgenden Namen erkannt: 

- README.*
- READ.ME
- *.TXT
- *.DOC

Beim Anzeigen von Textdateien rufen F1 oder HELP das HILFE-Men auf, in dem 
die Optionen beschrieben werden. Durch Drcken von ESC oder Cursor Rechts wird 
der Textbetrachter beendet und zur Spieleliste zurckgekehrt. Die Navigation 
in Textdateien erfolgt zeilenweise mit Cursor hoch und runter wenn die Textdatei 
zu gro ist, um auf einmal auf den Bildschirm zu passen. Darber hinaus scrollen 
Shift-Cursor-hoch und Shift-Cursor-runter den Text seitenweise. 

Das Standardfarbschema fr Textdateien ist schwarzer Text auf weiem 
Hintergrund. Falls gewnscht, kann dies in ein anderes Schema gendert werden. 
Derzeit sind die folgenden Schemata verfgbar: 

schwarzer Text weier Hintergrund (Standard)
weier Text schwarzer Hintergrund
grner Text schwarzer Hintergrund
roter Text schwarzer Hintergrund

Um die Palette zu ndern, drcken Sie entweder die Taste F2 oder 'p'. Das 
ausgewhlte Farbschema wird in der Konfigurationsdatei gespeichert und beim 
nchsten Programmstart automatisch verwendet. 

Der Textbetrachter kann Text in niedriger oder mittlerer Auflsung anzeigen.
Bei einer Anzeige in 80 Spalten bietet die mittlere Auflsung klareren Text.
Um die Auflsung des Textbetrachters einzustellen, rufen Sie den 
F2-Konfigurationsbildschirm auf und whlen Sie die Option
"r...Auflsung Textbetrachter". Die Auswahl kann in der Konfigurationsdatei
gespeichert werden, sodass sie beim Ausfhren des Men sofort aktiv ist. 

Wenn der Textbetrachter auf niedrige Auflsung eingestellt ist, knnen 
Textdateien entweder in 40 oder 80 Spalten oder auf AUTO angezeigt werden.
Um die Option fr den extbetrachter einzustellen, rufen Sie den 
F2-Konfigurationsbildschirm auf und whlen Sie die Option "c...Textbetrachterspalten".
Die Auswahl kann in der Konfigurationsdatei gespeichert werden, sodass sie
beim Ausfhren des Men sofort aktiv ist. Wenn AUTO gewhlt ist, whlt der
Textbetrachter je nach Zeilenlnge der Textdatei die Anzeige in 40 oder 80 Spalten. 

## Spielstnde

Das Men ermglicht es dem Benutzer, HAGA-System Spielstnde zu laden, 
wenn diese fr das jeweilige Spiel gefunden werden. Bei Drcken von F9 
in der Spieleliste oder von F9 oder Cursor Rechts in einem Spiel-Screenshot
wird geprft, ob gespeicherte Spielstnde fr dieses Spiel vorhanden sind. Wenn
welche vorhanden sind, wird dem Benutzer eine Liste zusammen mit dem
Screenshot des aktuell ausgewhlten Spielstandes angezeigt. Wenn mehrere 
Spielstnde vorhanden sind, wird durch Bewegen des Cursor nach oben oder unten 
ein Spielstand ausgewhlt und der zugehrige Screenshot angezeigt. Durch Drcken 
der Enter oder der Return-Taste wird der Spielstand speichern sofort geladen 
und ausgefhrt. Drcken von ESC oder Cursor Links kehrt Sie zum 
Spielauswahlmodus zurck. HAGA-System Spielstnde haben den Dateinamen GSXX.TOS, 
wobei XX eine zweistellige Zahl ist, und diese Dateien mssen im Ordner des Spiels 
liegen. Fr jedes Spiel knnen bis zu 16 Spielstnde vorhanden sein. 

Bitte beachten Sie, dass einige Spiele spezielle Hardwaretechniken verwenden, 
um die Anzahl der Farben auf dem Bildschirm und die Bildschirmauflsung  zu 
erhhen. HDMENU kann diese Techniken beim Anzeigen von Screenshots nicht 
verwenden, daher knnen einige Screenshots einen Spielbildschirm zeigen, 
der anders aussieht als im Spiel.  

## Musik

HDMENU kann optional eine Musikdatei im Hintergrund abspielen. Musikdateien 
mssen im SNDH-Format vorliegen. Musik kann auf zwei Arten aktiviert werden: 

Vom F2-Konfigurationsbildschirm:

  Drcken Sie "m", um durch die Optionen zu blttern:
  
  aus - Musik ist ausgeschaltet - VU-Meter ist ausgegraut und deaktiviert
  ein - spielt interne Musikdatei ab
  ext - eine externe Musikdatei wird verwendet. Die externe Musikdatei muss
        im selben Verzeichnis wie die Datenbankdatei HDMENU.CSV liegen. Die
	    externe Musikdatei muss im SNDH-Format vorliegen und kann gepackt
	    oder entpackt sein und muss die Dateiendung ".SND" haben. 

  Zustzlich kann ein VU-Meter (Lautstrkemesser mit 3-Kanal-Balkendiagramm) mit 
  der Taste "v" im F2-Men ein- und ausgeschaltet werden. Diese Option ist nur 
  verfgbar, wenn Musik eingeschaltet ist. Das VU-Meter wird oben links auf dem 
  Bildschirm angezeigt. 

Aus dem Hauptmen:

  Durch Drcken von SHIFT+F2 wird eine Liste der abzuspielenden .SND-Dateien 
  angezeigt. Diese Dateien mssen sich in einem MUSIC-Ordner befinden. 
  Standardmig sollte sich der MUSIC-Ordner im selben Verzeichnis wie 
  HDMENU.CSV befinden. Optional kann der Speicherort des MUSIC-Ordners in der 
  CSV-Datei angegeben werden. Weitere Informationen finden Sie im Abschnitt 
  "Datenbankdatei". Die Dateien werden als Liste angezeigt und durch Drcken
  der ENTER taste auf einer markierten Sounddatei wird die Musikwiedergabe 
  gestartet. 

  Die ausgewhlte Musikdatei kann in der CFG-Datei gespeichert und beim
  Start von HDMENU automatisch abgespielt werden. 

## Schriftarten

Das Men kann eine externe Schriftart verwenden. Die Schriftartdateien mssen 
das folgende Format aufweisen: 

95 Zeichen - 760 Bytes

 !"#$%&'()*+,-./0123456789:;<=>?
@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_
`abcdefghijklmnopqrstuvwxyz{|}~

Schriftdateien sind 8x8 Single-Plane mit 8 Bytes pro Zeichen:

Beispiel) 
                           (8 Zeilen hoch)
1. Byte   2. Byte   3. Byte   4. Byte   5. Byte   6. Byte   7. Byte   8. Byte   
Zeichen 1 Zeichen 1 Zeichen 1 Zeichen 1 Zeichen 1 Zeichen 1 Zeichen 1 Zeichen 1
Zeile 1   Zeile 2   Zeile 3   Zeile 4   Zeile 5   Zeile 6   Zeile 7   Zeile 8
00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
	    
                           (8 Zeilen hoch)
9. Byte   10. Byte  11. Byte  12. Byte  13. Byte  14. Byte  15. Byte  16. Byte   
Zeichen 2 Zeichen 2 Zeichen 2 Zeichen 2 Zeichen 2 Zeichen 2 Zeichen 2 Zeichen 2
Zeile 1   Zeile 2   Zeile 3   Zeile 4   Zeile 5   Zeile 6   Zeile 7   Zeile 8
00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000

und so weiter...

Schriftarten knnen auf zwei Arten aktiviert werden:

Vom F2-Konfigurationsbildschirm:

  Drcken Sie "f", um durch die Optionen zu blttern:
  
  intern - die standardmige interne Menschriftart verwenden
  extern - eine externe Schriftdatei wird aktiviert. Die externe Schriftdatei
	     muss sich im selben Verzeichnis wie die Datenbankdatei HDMENU.CSV
	     befinden. Die externe Schriftdatei muss im oben beschriebenen
	     FNT-Format vorliegen und die Dateierweiterung ".FNT" haben. 
	     Hinweis: Die Option "extern" ist nur verfgbar, wenn sich eine
	     externe Schriftart im Basisverzeichnis befindet oder wenn eine 
         bereits ber das Hauptmen aktiviert wurde (siehe unten). 

  
Aus dem Hauptmen:

  Durch Drcken von SHIFT+F3 wird eine Liste mit .FNT-Dateien zur Auswahl 
  angezeigt. Diese Dateien mssen sich in einem FONTS-Ordner befinden. 
  Standardmig sollte sich der FONTS-Ordner im selben Verzeichnis wie 
  HDMENU.CSV befinden. Optional kann der Speicherort des FONTS-Ordners in der 
  CSV-Datei angegeben werden. Weitere Informationen finden Sie im Abschnitt 
  "Datenbankdatei". Die Dateien werden als Liste angezeigt und unten auf dem 
  Bildschirm wird ein Beispiel des Schrifttexts angezeigt. Durch Drcken von ESC 
  wird das Men ohne nderungen an der aktuellen Schriftart wieder verlassen und 
  das Hauptmen wieder aufgerufen. Durch Drcken der ENTER taste auf einer 
  markierten Datei wird die neue Schriftart verwendet und das Hauptmen wieder 
  aufgerufen. 

  Die ausgewhlte Schriftdatei kann in der CFG-Datei gespeichert und beim
  Neustart des Mens automatisch verwendet werden. 

## Favoriten

Mit der optionalen Favoritenfunktion kann der Benutzer seine Lieblingsspiele 
markieren und in einer Liste anzeigen. 

Im Men werden Favoriten mit einem Sternchen vor dem Spieltitel gekennzeichnet. 
Um nur die Lieblingsspiele anzuzeigen, drcken Sie F5. Um zur vollstndigen 
Liste zurckzukehren, drcken Sie erneut F5. Wenn keine Lieblingsspiele 
markiert sind, hat das Drcken von F5 keine Wirkung. 

Es gibt zwei Mglichkeiten, ein Spiel als Favorit zu markieren. Mit einem 
Texteditor und im Menprogramm. 

- Um ein Lieblingsspiel manuell mit einem Texteditor zu markieren, stellen Sie
  dem Eintrag fr das Spiel in der CSV-Datei einfach ein Sternchen "*" voran.

  Beispiel:
  Hier ist das Spiel Wolfchild als Favorit markiert:
  *Wolfchild;C:\GAMES\W\WOLFCHIL\RUNME.TOS

  Hier ist das Spiel Wolfchild kein Favorit:
  Wolfchild;C:\GAMES\W\WOLFCHIL\RUNME.TOS

- Um ein Spiel ber das Menprogramm als Favorit zu markieren, drcken Sie die 
  Leertaste, wenn das Spiel markiert ist. Vor dem Spieltitel erscheint ein 
  Sternchen, das anzeigt, dass es jetzt ein Favorit ist. Um die Markierung 
  eines Favoriten aufzuheben, drcken Sie einfach erneut die Leertaste. 
  Das Sternchen verschwindet und zeigt an, dass das Spiel jetzt kein Favorit 
  mehr ist. 

  Das Umschalten des Favoritenstatus fr ein Spiel ist nur im Modus 
  "Vollstndige Liste" (sowohl im Listen- als auch im Screenshot-Modus) mglich. 
  Die Funktion ist im Modus "Favoritenliste" nicht aktiv, d.h. wenn F5 gedrckt 
  wurde, um nur Favoriten anzuzeigen. 

Favoriten, die in HDMENU markiert wurden, knnen in der CSV-Datei gespeichert 
werden, damit sie dauerhaft sind und bei spteren Verwendungen des Mens 
erkannt werden. Um dies zu untersttzen, wurde eine neue 
Konfigurationsbildschirmoption hinzugefgt - "b...CSV-Sicherungskopie". Wenn
diese optionale Einstellung aktiviert ist, sichert das Programm die aktuelle 
HDMENU.CSV-Datei in HDMENU.BAK, bevor die neue Datei geschrieben wird. Wenn 
die Einstellung deaktiviert ist, wird die aktuelle HDMENU.CSV-Datei 
berschrieben. 

Um nderungen an der CSV-Datei zu speichern, drcken Sie die Taste F7. Der 
Besttigungsbildschirm wird angezeigt. Durch Drcken von "j" oder "J" wird die 
neue Datei gespeichert. Durch Drcken von "n" oder "N" kehren Sie zum Men 
zurck, ohne die nderungen zu speichern. 

Wenn im Men nderungen vorgenommen und vor dem Beenden oder Starten eines 
Spiels nicht gespeichert werden, wird eine Besttigungsaufforderung angezeigt, 
damit der Benutzer entscheiden kann, ob die nderungen gespeichert werden 
sollen. 

Alle Favoriten fr eine ausgewhlte Kategorie knnen durch Drcken von
SHIFT-F5 gelscht werden.

## Konfiguration

Einige Konfigurationseinstellungen knnen in der CSV-Datei zugewiesen werden. 
Konfigurationseintrge beginnen mit einem "@"-Zeichen, gefolgt von einem 
Schlsselwort und einem Wert. 

Konfigurationseinstellungen mssen ganz am Anfang der Datenbankdatei stehen.
Konfigurationseinstellungen sind optional.

Verfgbare Konfigurationsschlsselwrter sind:

MUSIC=
FONTS=
DEFCAT=

Beispiel)
@MUSIC=C:\MUSIC			Speicherort der Musikdateien
@FONTS=C:\EXTRAS\FONTS		Speicherort der Schriftdateien
@DEFCAT=Demos			Kategorie, die bei Programmstart angezeigt werden soll

## Kommentare

In der CSV-Datei knnen Kommentare vorhanden sein. Eine Kommentarzeile muss 
mit dem Zeichen ";" beginnen. Kommentarzeilen werden in der Menliste nicht 
angezeigt, bleiben aber erhalten wenn die Datenbankdatei mit der Option F7 
gespeichert wird. 

## Spezifikationen

Fr jeden Spieleintrag gibt es mehrere Felder in der Datenbank. 
Sie beginnen mit einem '='-Zeichen, gefolgt von einer Typkennung 
'a' - 'v'. Danach folgt ein Komma, gefolgt vom Eintrag des Feldes. Die 
Typkennungen 'w' - 'z' haben eine besondere Bedeutung und werden im 
Spezifikationsabschnitt der CSV-Datei nicht festgelegt - siehe 
unten im Abschnitt "Daten:". 

Typdefinitionen mssen ganz am Anfang der Datenbankdatei stehen
oder direkt auf Konfigurationseinstellungen folgen, falls diese vorhanden sind.

Typefinitionen sind optional.

Beispiele:
=c,Sports

definiert eine Kategorie "Sport".

=p,Ocean

definiert einen Herausgeber "Ocean".

Die verfgbaren Spezifikationskennungen sind wie folgt:

 a - Autor              Name des Programmierers
 b - Erscheinungs_Typ   Release-Typ, d.h. kommerziell, Freeware, Shareware usw.
 c - Kategorie          Kategorie, z.B. Spiele, Demos usw.
 d - Entwickler         Spieleentwickler
 e - Umgebung           Erforderliche Betriebssystemumgebung, d.h. TOS oder AES usw.
 f - Sync-Typ           Video-Norm, z.B. 50 Hz, 60 Hz, NTSC, PAL usw.
 g - Netzwerk           Spielnetzwerke, d.h. seriell, MIDI, Ethernet usw.
 h - Komponist          Name des Komponisten
 i - Steuerung          Steuerungsmethode, z.B. Joystick, Maus, Tastatur usw.
 j - Minimum TOS        Mindestens erforderliche TOS-Version
 k - Sonstiges          Sonstige Details, z.B. 4-Spieler-Adapter usw.
 l - Sprache            Sprache z.B. En, De, Fr, usw.
 m - Basismaschine      Maschinentyp, z.B. ST, STE, TT, Falcon, usw. 
 n - Spieler            Anzahl der Spieler, d.h. 1, 2, 4
 o - Land               Herkunftsland, d.h. USA, UK, Deutschland, Frankreich, usw.
 p - Herausgeber        Herausgeber z.B. Ocean, Mindscape usw.
 q - Prog.-Sprache      Verwendete Programmiersprache, d.h. Assembler, GFA-Basic, usw.
 r - Mindestspeicher    Erforderlicher Speicher, d.h. 512K, 1MB, 2MB, 4MB, usw.
 s - Sound-typ          Ton z.B. YM2149, DMA, MIDI, usw.
 t - Genre              Genre z.B. Plattformspiel, Maze Runner usw.
 u - Adapt-typ          Art der Festplattenadaption, d.h. D-BUG, ULS, GAMEX, HAGA, usw.
 v - Video-typ          d.h ST-Low, ST-Mittel, Mono, RGB, VGA, usw.
 w - Adapt_Monat        Monat der Verffentlichung der Festplattenadaption
 x - Adapt_Jahr         Jahr der Verffentlichung der Festplattenadaption
 y - Erscheinungs_Monat Monat der ursprnglichen Verffentlichung des Spiels
 z - Erscheinungs_Jahr  Jahr der ursprnglichen Verffentlichung des Spiels

Spezifikationskennungen werden einem Datenbankeintrag zugeordnet, beginnend 
bei 1, wenn sie in der Datenbankdatei gefunden werden, und es knnen bis zu 
255 Eintrge fr jede Spezifikation vorhanden sein. 

Beispiel:

=c,Sports
=c,Platformer
=c,RPG

wrde die Kategorie Sports mit 1, Platformer mit 2 und RPG mit 3 assoziieren.

=p,Ocean
=p,US Gold

wrde den Herausgeber Ocean mit 1 und US Gold mit 2 assoziieren.

=u,ULS
=u,GAMEX
=u,HAGA

wrde den  Adaptionstyp ULS mit 1, GAMEX mit 2 und HAGA mit 3 assoziieren.

Um eine Spezifikationskennung mit einem bestimmten Spieleeintrag zu 
verknpfen, geben Sie nach dem Eintragspfad ein ";" ein, gefolgt vom 
Spezifikationszeichen und der mit der Kennung verbundenen Nummer. 

Betrachten Sie beispielsweise die kleine Datenbank unten:

=c,Sports
=c,Platformer
=c,RPG
=u,GAMEX
=u,HAGA
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS
Great Giana Sisters;C:\GAMES\G\GGSBLITT\GILAUB.TOS

wrde drei Kategorien "Sport", "Platformer" und "RPG" und zwei Adaptionstypen
"GAMEX" und "HAGA" vor dem ersten Spieleintrag definieren, der "10th Frame"
wre, gefolgt von "Great Giana Sisters". 

So verknpfen Sie Spezifikationskennungen mit den Spieleintrgen:

Beispiel:
Keine Spezifikationen zugewiesen
----------------------
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS
Great Giana Sisters;C:\GAMES\G\GGSBLITT\GILAUB.TOS

Kategorie "Sport" (Kategorie 1) zugewiesen Spiel
-----------------------------------------------
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS;c1

Kategorie "Platformer" (Kategorie 2) zugewiesen an Spiel
---------------------------------------------------
Great Giana Sisters;C:\GAMES\G\GGSBLITT\GILAUB.TOS;c2

Adaptionstyp "GAMEX" (Adaption 1) dem Spiel zugewiesen
-------------------------------------------------------
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS;u1

Adaptionstyp "HAGA" (Adaption 2) dem Spiel zugewiesen
-------------------------------------------------------
Great Giana Sisters;C:\GAMES\G\GGSBLITT\GILAUB.TOS;u2

Kategorie "Sport" (Kategorie 1) und
Adaptionstyp "GAMEX" (Adaption 1) dem Spiel zugewiesen
-------------------------------------------------------
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS;c1;u1

Kategorie "Platformer" (Kategorie 2) und 
Adaptionstyp "HAGA" (Adaption 2) dem Spiel zugewiesen
-------------------------------------------------------
10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS;c2;u2


Kategorien sind eine spezielle Art der Spezifikation. Spiele werden auf zwei 
Arten einer Kategorie zugewiesen: manuell in der CSV-Datei oder ber das Men. 

Die manuelle Zuweisung einer Kategorie zu einem Spiel erfolgt wie oben 
beschrieben. 

Innerhalb des Mens knnen einem Spiel Kategorien mit LinksShift-F6 
in der vollstndigen Liste zugewiesen werden (nicht in den Favoriten oder der
Kategorieliste). 

Nach dem Drcken von LinksShift-F6 wird die Liste der in der CSV-Datei 
gefundenen Kategorien angezeigt und der Benutzer kann die Kategorie auswhlen, 
die dem Spiel zugewiesen werden soll. Durch Auswahl der internen Kategorie 
"Keine" werden alle dem Spiel zugewiesenen Kategorien entfernt. Wenn keine 
Kategorien definiert sind, wird eine entsprechende Meldung angezeigt. 

Durch Drcken von F6 im Modus "Vollstndige Liste" kann der Benutzer eine 
Kategorie zur Anzeige auswhlen. Alle dieser Kategorie zugewiesenen Spiele 
werden angezeigt. Wenn keine Kategorien definiert sind, wird eine 
entsprechende Meldung angezeigt. 
Die Favoriten fr diese Kategorie funktionieren genauso wie bei der 
vollstndigen Liste (Taste F5) und knnen in der vollstndigen Kategorienliste 
genauso ein- und ausgeschaltet werden wie in der normalen vollstndigen Liste. 

Im Men lassen sich mit der Tastenkombination SHIFT-F1 die 
Datenbankspezifikationen zu einem Spieleeintrag anzeigen. Dabei werden ggf. 
in der Datenbankdatei dem Eintrag zugeordnete Spezifikationen angezeigt. 

Wenn die optionale Statusleiste aktiv ist, werden bestimmte 
Spielspezifikationen unten auf dem Bildschirm angezeigt, wenn sie fr einen 
Spieleintrag definiert sind: 
(Hinweis: Die Statusleiste kann im F2-Konfigurationsbildschirm aktiviert/
deaktiviert werden)

- Zum Ausfhren des Eintrags erforderlicher Maschinentyp
- Zum Ausfhren des Eintrags erforderlicher Speicher
- Auflsung, in der der Eintrag ausgefhrt wird
- Videofrequenz, mit der der Eintrag ausgefhrt wird
- Der vom Eintrag verwendete Steuerung (Tastatur, Joystick, ...)
- Anzahl der vom Eintrag untersttzten Player

Daten:

Die Spezifikationen 'w' - 'z' sind eindeutig und werden nicht vom Benutzer 
definiert. Sie stellen die Daten der ursprnglichen Verffentlichung des 
Spiels und die Daten dar, an denen die Festplattenadaption verffentlicht 
wurde: 

 w - Adapt_Monat		  Monat der Verffentlichung der Festplattenadaption
 x - Adapt_Jahr 		  Jahr der Verffentlichung der Festplattenadaption
 y - Erscheinungs_Monat	  Monat der ursprnglichen Verffentlichung des Spiels
 z - Erscheinungs_Jahr	  Jahr der ursprnglichen Verffentlichung des Spiels

Um ein Datum mit einem bestimmten Spieleintrag zu verknpfen, geben Sie nach 
dem Eintragspfad ein ";" gefolgt vom Spezifikationszeichen und einer Nummer 
wie folgt ein: 

Monat 1-12
Jahr  1-255 als Offset von 1980

Beispiel:

10th Frame;C:\GAMES\0\10THFRAM\RUNME.TOS;w10;x42;y2;z7

w10 = Monat 10 (Adapt_Monat)

x42 = 1980+42 Jahr 2022 (Adapt_Jahr)

y2 = Monat 2 (Erscheinungs_Monat)

z7 = 1980 + 7 Jahr 1987 (Erscheinungs_Jahr)

In diesem Beispiel wurde das Originalspiel im Februar 1987 verffentlicht
und die Festplattenadaption erschien im Oktober 2022.

Wie bei allen Spezifikationen ist ihre Existenz fr den Benutzer optional.

## Statuszeile

Wenn die optionale Statuszeile im F2-Konfigurationsbildschirm aktiviert ist, 
werden in der unteren Bildschirmzeile einige zustzliche Informationen 
angezeigt: 

Unten rechts wird die Gesamtzahl der Spiele in der Liste angezeigt. Fr die 
Hauptliste ist dies die Gesamtzahl der Spiele in der Datenbank. Wenn eine 
Kategorie- oder Favoritenliste ausgewhlt ist, stellt die Zahl die Anzahl der 
Spiele in diesen jeweiligen Listen dar. 

Darber hinaus werden diese Spezifikationsfeldwerte angezeigt, sofern sie in 
der Datenbank fr den aktuellen Spieleintrag eingetragen sind
(siehe Abschnitt "Spezifikationen"): 
Adapt-typ
Basismaschine
Mindestspeicher
Video-typ
Sync-Typ
Steuerung
Spielerzahl
Sprache
Sonstiges

## Programminstallation

Fr ST/STE/TT/Falcon 030
  Das Programm ist fr den Start aus dem AUTO-Ordner vorgesehen. Es kann per 
  Doppelklick vom Desktop aus ausgefhrt werden, allerdings werden dann die 
  meisten seiner Ideen nutzlos. (Ausnahme Apollo V4SA)
 
  - Kopiere HDMENU.PRG in den AUTO-Ordner
  - Lege eine Datenbankdatei C:\HDMENU.CSV an
  
  Das Programm fordert Sie auf, zum Men zu gehen oder den Desktop zu starten. 
  Das Verhalten und der Zeitpunkt der Eingabeaufforderung knnen mithilfe einer 
  Konfigurationsoption umgeschaltet werden. 

Fr Apollo V4SA
  Das Programm sollte vom Desktop aus gestartet werden und ffnet direkt das Men.

### AUTO-Ordnerreihenfolge

Um HDMENU optimal nutzen zu knnen, sollte es vor anderen 
Programmen und Treibern im AUTO-Ordner stehen. Platzieren Sie nur notwendige 
Dienstprogramme wie FPATCH2.PRG davor. 

Verwenden Sie ein Tool wie AUTOSORT, um die Reihenfolge anzupassen.

Es ist eine Verschwendung von Speicher, zuerst NVDI zu laden und anschlieend
HDMENU auszufhren.

### Datenbankdatei

Die Datenbankdatei befindet sich immer in dem Ordner, von dem aus 
HDMENU.PRG gestartet wird, oder im Stammverzeichnis des Startlaufwerks, wenn 
es aus dem AUTO-Ordner gestartet wird, und muss den Namen "HDMENU.CSV" haben. 
Die Datenbankdatei ist eine CSV-Tabelle mit durch Strichpunkt ";" getrennten 
Eintrgen. 

Wenn das erste Zeichen der Zeile mit "@" beginnt, gefolgt von einem
Schlsselwort und einem Wert, wird die Zeile als Konfigurationsdefinition 
interpretiert. (Siehe Abschnitt "Konfiguration").

Typdefinitionen mssen ganz am Anfang der Datenbankdatei stehen.
Typdefinitionen sind optional.

Wenn das erste Zeichen einer Zeile mit "=" beginnt, gefolgt von den Buchstaben 
'a' - 'v', wird die Zeile als Typdefinition interpretiert. 
(Siehe Abschnitt "Spezifikationen").

Spezifikationsdefinitionen mssen ganz am Anfang der Datenbankdatei oder
unmittelbar nach etwaigen Konfigurationsdefinitionen stehen, sofern vorhanden.
Spezifikationsdefinitionen sind optional.

Zeilen, die keine Konfigurations- oder Spezifikationsdefinitionen sind,
sind Spiel-Eintragszeilen.

Leere Zeilen oder Zeilen mit nur einer Datenspalte werden ignoriert und 
bleiben beim anschlieenden Speichern der Datenbank im Men ber die Taste F7 
nicht erhalten. 
Ausgenommen hiervon sind Zeilen, die mit ";" beginnen. Diese Zeilen werden als 
Kommentarzeilen betrachtet und nicht in der Menliste angezeigt, bleiben aber 
beim Speichern der Datenbank erhalten. 

Die ersten beiden Felder der Spiel-Eintragzeilen werden wie folgt interpretiert:

- Feld 1 enthlt den Eintragsnamen mit bis zu 50 Zeichen. (Im Men werden nur 
  die ersten 36 Zeichen angezeigt. Wenn der Eintrag lnger als 36 Zeichen ist, 
  werden die letzten 3 Zeichen bei der Anzeige im Men in "..." gendert.) 

  Wenn das erste Zeichen in Feld 1 ein "*" ist, wird das Spiel als Favorit 
  gekennzeichnet. Weitere Informationen finden Sie im Abschnitt "Favoriten" 
  dieses Textes. 

- Feld 2 enthlt den vollstndigen Pfad zur ausfhrbaren Datei

- Die Felder 3-29 sind optional und enthalten die mit dem Spiel 
  verbundenen Spezifikationskennungen. Weitere Einzelheiten finden Sie im 
  Abschnitt "Spezifikationen" dieses Textes. 

Bei unvollstndigen Pfaden wird davon ausgegangen, dass sie sich auf demselben 
Basislaufwerk befinden. Wenn das Men beispielsweise vom Laufwerk F aus 
ausgefhrt wird, werden Ordner und ausfhrbare Dateien von diesem Laufwerk aus 
gesucht. 

Am sichersten ist es, vollstndige, gltige GEMDOS-Pfadnamen inklusive 
Laufwerksbuchstaben anzugeben. Bei Dateinamen wird die Gro- und 
Kleinschreibung ignoriert, der angegebene Laufwerksname wird ausgewhlt, so 
dass das Ausfhren des Mens von C: aus Ihre Spiele mglicherweise trotzdem 
von D: oder E: aus ausfhren kann. 

Der Eintragsname selbst wird unverndert angezeigt. Eintrge sind nur gltig, 
wenn der Eintragsname mindestens 1 Zeichen lang ist. Wenn der Eintrag zu lang 
ist, um auf den Bildschirm zu passen, werden die letzten 3 Zeichen in "..." 
gendert, um dies anzuzeigen. 

Ein Beispiel fr einen CSV-Eintrag knnte wie folgt aussehen:

Exolon (von Klapauzius);E:\GAMES\EXOLON\EXOLON.PRG

Die Anzahl der Eintrge in der Datenbankdatei wird nur durch den verfgbaren
Speicher begrenzt.

Mit der Taste F7 kann die Datenbankdatei gespeichert werden. Dadurch werden 
die vorgenommenen nderungen in die CSV-Datei geschrieben und werden beim 
nchsten Stert von HDMENU wieder geladen. Wurde die Datenbank mit der Taste 
F8 sortiert, wird die neue CSV-Datei alphabetisch sortiert. 

Die Datenbankdatei kann mit der Tastenkombination Umschalt-F7 neu geladen 
werden. Dies kann beim Bearbeiten und Testen einer CSV-Datei, z.B. unter 
einem Emulator, ntzlich sein. Alle vor dem Neuladen vorgenommenen nderungen 
gehen verloren. 

## Videomodus fr Falcon RGB

Falls Sie bei Falcons mit RGB-Monitor kein brauchbares Bild erhalten, drcken 
Sie whrend der AUTO-Initialisierung '*' auf dem Ziffernblock, um den 
alternativen Video-Initialisierungscode zu aktivieren. Wenn die Einstellungen 
funktionieren, speichern Sie Ihre Einstellungen aus dem Konfigurationsmen auf 
die Festplatte. 

Beim nchsten Start von HDMENU sollte der alternative Videocode verwendet werden.

## Danksagung

Dank und Anerkennung gehen an die folgenden Atarianer

- Simon Sunnyboy fr das Original Atari ST Harddisk Menu!
- Thorsten Otto zur Anbindung der Alive 80-Spalten-Fontroutine an C.
- mfro fr die hervorragende libcmini
- evil fr Details zum SNDH-Dateiformat
- Jeff fr seinen HxC-Selektor, der mich dazu inspirierte, etwas hnliches fr
  Festplatten zu entwickeln
- Vincent Riviere fr die Bereitstellung eines hervorragenden Cross-Compilers
  fr Linux
- MSD/POV fr seinen Lauf eine Programmroutine, die den grten Teil des
  Speichers freigibt
- Damien Guard fr seine fantastische Sammlung von 8x8 Bitmap-Schriftarten
- Terry King fr seine Fontroutine von SpriteWorks
- Pursy von D-Bug fr die Logo-Schriftart
- D-Bug/Klapauzius/Ppera fr die Bereitstellung einer Flle von Spielen mit
  Festplatten-Patches, die mit diesem Dienstprogramm ausgefhrt werden knnen
- Eero Tamminen und joska fr einige Usability-Ideen

Besonderer Dank gilt allen geduldigen und fleiigen Testern, die dazu
beigetragen haben, dieses Programm noch besser zu machen:

- DarkLord
- JezC
- Jordi aka "crashman"
- Mikerochip
- Piotr "Kroll" Mietniowski

Ganz besonderer Dank geht an Ektus fr die unglaubliche Hilfe bei der
deutschen bersetzung.

Ich hoffe, Sie finden das Tool ntzlich.

STay cool, STay Atari /|\
